//******************************************************************************
// Joole.java:	Applet
//
//******************************************************************************
import java.applet.*;
import java.awt.*;

import CBoolFkt.*;
import ShowCopyright.*;

//==============================================================================
// Hauptklasse fuer Applet Joole
//
//==============================================================================
public class Joole extends Applet
{
	// Berechnungsobjekt erstellen
	CBoolFkt Fkt = new CBoolFkt();


	// Eingabefeld der Aussagen
	TextField tfEingabe;
	// Auswertung starten
	Button doEval;
	// XYZ als ABC
	Checkbox cbXYZ2ABC;

	// Ausgabefeld
	TextArea taWerte;

	// Ausgabe der Normalformen
	TextField tfANF, tfVDNF, tfMDNF, tfVKNF;
	// Ausgabe der Klassenzugehoerigkeiten
	Label laK0, laK1, laKsd, laKlinear, laKmonoton, laSheffer;

	// Logo und Copyright am unteren Rand anzeigen
	ShowCopyright scLogo;



	// Programminfo zurueckgeben
	public String getAppletInfo()
	{
		return "Name: Joole\r\nAutor: Stephan Brumme\r\n"+
               "Funktion: Auswertung boolescher Funktionen";
	}


	// Bildschirmlayout festlegen
	public void init()
	{
		// Standardgroesse herstellen
		resize(500,500);

		setLayout(new BorderLayout());

		// Eingabe
		Panel paEingabe = new Panel();
		paEingabe.setLayout(new BorderLayout());

		tfEingabe = new TextField();
		doEval  = new Button("Auswerten !");
		cbXYZ2ABC = new Checkbox("Variablen x,y,z durch a,b,c ersetzen",null,true);
		paEingabe.add("North",new Label("Ausdruck: "));
		paEingabe.add("Center",tfEingabe);
		paEingabe.add("East",doEval);
//		paEingabe.add("South",cbXYZ2ABC);


		taWerte = new TextArea();
		// schreibgeschuetzt
		taWerte.setEditable(false);

		// Normalformen
		Panel paNF = new Panel();
		paNF.setLayout(new BorderLayout());

		Panel paNFLabel = new Panel();
		Panel paNFTextFields = new Panel();
		paNFLabel.setLayout(new GridLayout(4,1));
		paNFTextFields.setLayout(new GridLayout(4,1));

		tfVDNF = new TextField();
		tfMDNF = new TextField();
		tfVKNF = new TextField();
		tfANF = new TextField();
		// alle schreibgeschuetzt
		tfVDNF.setEditable(false);
		tfMDNF.setEditable(false);
		tfVKNF.setEditable(false);
		tfANF.setEditable(false);

		paNFLabel.add(new Label("vDNF:"));
		paNFLabel.add(new Label("mDNF:"));
		paNFLabel.add(new Label("vKNF:"));
		paNFLabel.add(new Label("ANF:"));
		paNFTextFields.add(tfVDNF);
		paNFTextFields.add(tfMDNF);
		paNFTextFields.add(tfVKNF);
		paNFTextFields.add(tfANF);

		paNF.add("West",paNFLabel);
		paNF.add("Center",paNFTextFields);


		// Klassen
		Panel paKlassen = new Panel();
		paKlassen.setLayout(new GridLayout(3,4));
		laK0 = new Label();
		laK1 = new Label();
		laKsd = new Label();
		laKlinear = new Label();
		laKmonoton = new Label();
		laSheffer = new Label();
		paKlassen.add(new Label("0-erhaltend: ",Label.RIGHT));
		paKlassen.add(laK0);
		paKlassen.add(new Label("selbstdual: ",Label.RIGHT));
		paKlassen.add(laKsd);
		paKlassen.add(new Label("1-erhaltend: ",Label.RIGHT));
		paKlassen.add(laK1);
		paKlassen.add(new Label("linear: ",Label.RIGHT));
		paKlassen.add(laKlinear);
		paKlassen.add(new Label("monoton: ",Label.RIGHT));
		paKlassen.add(laKmonoton);
		paKlassen.add(new Label("Sheffer: ",Label.RIGHT));
		paKlassen.add(laSheffer);

		// Klassen und Normalformen zusammenpacken
		Panel paZusatz = new Panel();
		paZusatz.setLayout(new GridLayout(2,1));
		paZusatz.add(paNF);
		paZusatz.add(paKlassen);


		// Rahmen basteln, damit ein Rand entsteht
		Panel paRahmen = new Panel();
		paRahmen.setLayout(new BorderLayout());

		paRahmen.add("North",paEingabe);
		paRahmen.add("Center",taWerte);
		paRahmen.add("South",paZusatz);

		// Copyright darf natuerlich nicht vergessen werden ;)
		scLogo = new ShowCopyright(getImage(getDocumentBase(),"JooleLogo.jpg"));

		add("Center",paRahmen);
		add("North",new Label("  "));
		add("East",new Label("  "));
		add("West",new Label("  "));
		add("South",scLogo);
	}


	// es wurde [Enter] gedrueckt, bzw. "Auswerten !" aktiviert
	public boolean action(Event event, Object what)
	{
		// nur die Ereignisse bzgl. Auswertung interessieren
		if ((event.target==doEval)||(event.target==tfEingabe))
		{
			StringBuffer sFehler = new StringBuffer("Bei der Auswertung sind Probleme aufgetreten:\r\n");

			// Aussage holen
			Fkt.sExpression = tfEingabe.getText();

			// auf Syntax testen
			int Result=Fkt.Format();

			// bei Fehler auch entsprechende Meldung ausgeben
         if (Result == Fkt.Parser.NOTOKEN)
            sFehler.append("Kein Ausdruck eingegeben.");
         if (Result == Fkt.Parser.UNKNOWNTOKEN)
            sFehler.append("Der Ausdruck enthlt ungltige oder falsche Zeichen.");
         if (Result == Fkt.Parser.NOVARS)
            sFehler.append("Keine Variablen in der Aussagen enthalten.");
         if (Result == Fkt.Parser.VAREXPECTED)
            sFehler.append("Variable erwartet.");
         if (Result == Fkt.Parser.BRACKETEXPECTED)
            sFehler.append("Schlieende Klammer erwartet.");
         if (Result == Fkt.Parser.BRACKETEXPECTED)
            sFehler.append("Schlieende Klammer nicht erlaubt.");

			// Fehlermeldung noch etwas ausschmuecken
			if (Result!=Fkt.Parser.OK)
			{
				taWerte.setText(sFehler.append("\r\n(Fehlercode ").append(Result).append(", Zeichen ").
								append(Fkt.Parser.sValidInput.length()+1).append(")").toString());

				// Bearbeitung hier beenden
				return true;
			}

			// Wertetabelle berechnen
			Fkt.DoCalc();

			// Aussage durch ihr formatiertes Pendant ersetzen
			tfEingabe.setText(Fkt.sValidInput);

			// Rechenergebnisse ausgeben
			UpdateWerte();

			// Ereignis bearbeitet
			return true;
		}

		// den Rest weiterleiten an die Vaterklasse
		return super.action(event,what);
	}


	// Ausgabe der errechneten Eigenschaften der Booleschen Funktion
	public void UpdateWerte()
	{
		StringBuffer sAusgabe = new StringBuffer();

		// Wertetabelle ausgeben
		for (int nCount = 0; nCount<Fkt.nAmount; nCount++)
		{
			sAusgabe.append("   f (");
			for (int nBit = 0; nBit<Fkt.nVars; nBit++)
				if (Fkt.IsBitSet(nCount,Fkt.nVars-nBit-1))
					sAusgabe.append(" 1,");
				else
					sAusgabe.append(" 0,");

			sAusgabe.setLength(sAusgabe.length()-1);

			if (Fkt.arResults[nCount])
				sAusgabe.append(" ) = 1\r\n");
			else
				sAusgabe.append(" ) = 0\r\n");
		}
		sAusgabe.setLength(sAusgabe.length()-2);

		taWerte.setText(sAusgabe.toString());

		// Normalformen
		tfVDNF.setText(Fkt.sVDNF.toString());
		tfMDNF.setText(Fkt.sMDNF.toString());
		tfVKNF.setText(Fkt.sVKNF.toString());
		tfANF.setText(Fkt.sANF.toString());

		// Klassenzugehoerigkeiten
		if (Fkt.isK0)
			laK0.setText("ja");
		else
			laK0.setText("nein");

		if (Fkt.isK1)
			laK1.setText("ja");
		else
			laK1.setText("nein");

		if (Fkt.isKsd)
			laKsd.setText("ja");
		else
			laKsd.setText("nein");

		if (Fkt.isKlinear)
			laKlinear.setText("ja");
		else
			laKlinear.setText("nein");

		if (Fkt.isKmonoton)
			laKmonoton.setText("ja");
		else
			laKmonoton.setText("nein");

		if ((!Fkt.isK0)&&(!Fkt.isK1)&&(!Fkt.isKsd)&&
			(!Fkt.isKlinear)&&(!Fkt.isKmonoton))
			laSheffer.setText("ja");
		else
			laSheffer.setText("nein");

	}
}